.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm

SpeedTest	= 2	; 2=time without output, 1=output please, does not work for Greg's code which uses latest MMX string
UseMMX	= 0
UseBsr	= 0
UseGreg	= 0

; if UseMMX or SpeedTest
	.xmm
; endif

ShowQwFpu	PROTO: DWORD	; (does not work properly, ignore)
ShowQwMMX 	PROTO: DWORD
ShowQwBsr	PROTO: DWORD
ShowBytes	PROTO pqwBytes:PTR QWORD

flexbyte$ MACRO ptrQword:REQ
  ifndef FlexByteBuffer
	.data?
	FlexByteBuffer	dd 4 dup (?)
	.code
  endif
  if UseMMX
	invoke ShowQwMMX, ptrQword
  elseif UseBsr
	invoke ShowQwBsr, ptrQword
  elseif UseGreg
	invoke ShowBytes, ptrQword
  else
	invoke ShowQwFpu, ptrQword
  endif
  EXITM <offset FlexByteBuffer>
ENDM

TestNum MACRO testnum:REQ
LOCAL tmp$
	tmp$ CATSTR <">,<testnum>,<">
	print chr$(tmp$, 9)
	counter_begin LoopCount, HIGH_PRIORITY_CLASS
		mov eax, offset testnum
		mov eax, flexbyte$(eax)
	counter_end
	print ustr$(eax)," cycles", 9
	print offset FlexByteBuffer, 13, 10
ENDM

.data?
SPT	dd ?
wfd	WIN32_FIND_DATA <?>
fSize	dq ?
fHandle	dd ?
buffer	db 260 dup (?)

.data
Test0	dq	123		; 123 bytes
Test1	dq	129446708	; 123.45000076 MB
Test2	dq	132553428173	; 123.45 GB
Test3	dq	135734710449000	; 123.45000000005 TB, 123.45: 135734710448950
Test4	dq	138992343499720000	; 123.45 PB
; Test5 too large	dq	142328159743930000000	; 123.45 EB

qwEBi	REAL4	8.67361737988404E-17
qwPBi	REAL4	8.88178419700125E-14
qwTBi	REAL4	9.09494701772928E-11
qwGBi	REAL4	9.31322574615479E-8
qwMBi	REAL4	9.5367431640625E-05
qwKBi	REAL4	0.09765625
t6	db 9,	"EB", 0
t5	db 9,	"PB", 0
t4	db 9,	"TB", 0
t3	db 9,	"GB", 0
t2	db 9,	"MB", 0
t1	db 9,	"kB", 0
t0	db 9,	"bytes", 0

.code
start:	push ebx				; save counter
	mov SPT, SpeedTest
	if SpeedTest
		LoopCount = 100
		invoke Sleep, 500

		UseMMX = 0
		UseBsr	= 1
		UseGreg = 0
		print chr$(13,10,"BSR, ")
		mov eax, dummyBsr-ShowQwBsr
		print ustr$(eax)
		print chr$(" bytes:",13,10)

		TestNum Test0
		TestNum Test1
		TestNum Test2
		TestNum Test3
		TestNum Test4

		UseMMX = 1
		UseBsr	= 0
		print chr$(13,10,"MMX, ")
		mov eax, dummyMMX-ShowQwMMX
		print ustr$(eax)
		print chr$(" bytes:",13,10)

		TestNum Test0
		TestNum Test1
		TestNum Test2
		TestNum Test3
		TestNum Test4

		UseMMX = 0
		UseBsr	= 0
		UseGreg = 1
		mov SPT, 2	; no crt_printf please
		print chr$(13,10,"Greg, ")
		mov eax, dummyGreg-ShowBytes
		print ustr$(eax)
		print chr$(" bytes:",13,10)

		TestNum Test0
		TestNum Test1
		TestNum Test2
		TestNum Test3
		TestNum Test4

		print chr$(13,10,10)
		inkey "Press any key to exit..."
	else
	; invoke FindFirstFile, chr$("\Masm32\*.*"), addr wfd
	invoke GetCurrentDirectory, 260, offset buffer
	invoke lstrcat, offset buffer, chr$("\*.*")
	invoke FindFirstFile, offset buffer, addr wfd

	mov fHandle, eax
	.While eax
		print chr$(13,10)
		mov ecx, offset fSize		; we need to store the file size elsewhere ...
		mov eax, wfd.nFileSizeHigh	; ... because stupidly enough, the wfd order...
		mov [ecx+4], eax
		mov eax, wfd.nFileSizeLow	; ... is wrong, so we have to invert it
		mov [ecx], eax

		print flexbyte$(ecx)			; format [ecx] nicely: ecx is a pointer to a QWORD

		print chr$(9)
		print addr wfd.cFileName
		invoke FindNextFile, fHandle, addr wfd
	.Endw
	invoke FindClose, fHandle

	if UseMMX
		mov ebx, chr$("The size of the MMX flexbyte$ proc (bytes): ")
		mov ecx, dummyMMX-ShowQwMMX
	elseif UseBsr
		mov ebx, chr$("The size of the Bsr flexbyte$ proc (bytes): ")
		mov ecx, dummyBsr-ShowQwBsr
	else
		mov ebx, chr$("The size of the standard flexbyte$ proc (bytes): ")
		mov ecx, dummyFpu-ShowQwFpu
	endif
	if 1
		invoke MessageBox, 0, str$(ecx), ebx, MB_OK
	else
		push ecx
		print chr$(13,10,10)
		print ebx
		pop ecx
		print str$(ecx)
	endif
	endif	; end SpeedTest
	print chr$(13, 10)
	pop ebx
	invoke ExitProcess, 0

align 16
ShowQwMMX proc uses edi esi pNum:DWORD
  mov esi, pNum					; pointer to our 8-byte number
  movq mm0, qword ptr [esi]		; move the number into mm0
  movq mm1, mm0				; move a copy to mm1
  mov edi, 6						; we have 6 different units
  mov ecx, 1024*1024				; divisor
  movd mm2, ecx					; put the "divisor" into mm2, and let it start with 2^20

@@:	movq mm3, mm2			; use a copy of the divisor
	; psubq mm3, mm0			; subtract original number: no opcode
	db 0fh, 0fbh, 0d8h 			; in ML 6.14, so we must poke it directly
	pextrw eax, mm3, 3			; extract highest word (0...3); although word sized,
	test eax, 08000h
	; or eax, eax				; affects eax, so or eax is safe
	je @F						; jump if equal (it's either 0 or ffff)
	psllq mm2, 10				; multiply divisor by 1024
	psrlq mm1, 10				; divide number by 1024
	dec edi						; choose the next higher unit
	jnz @B

@@:
  movd eax, mm1    				; the remainder
  xor ecx, ecx						; for flag and multiply

  .if edi<6 || eax>=1024
	add ecx, 100
	mul ecx
	sar eax, 10					; divide by 1024
	dec edi
  .endif
	.if SPT!=2
  push ecx						; flag decimals
  mov esi, offset FlexByteBuffer
  invoke dwtoa, eax, esi
  pop ecx							; pop flag decimals
  .if ecx							; add the dot
	mov edx, [esi+len(esi)-2]	; len returns eax, so we use ecx as accu
	mov cl, "."
	mov [esi+eax-2], cl
	mov [esi+eax-1], edx
  .endif
  lea edi, [t6+4*edi]				; our unit
  invoke lstrcat, esi, edi			; add the xByte unit
	.endif
  emms							; be nice to others: cleanup
  ret
ShowQwMMX endp

dummyMMX proc
dummyMMX endp

ShowQwFpu proc uses edi esi ebx pNum:DWORD
LOCAL TmpR4:REAL4
  ffree st(7)		; instead of expensive finit
  mov esi, pNum		; pointer to our 8-byte number
  lea edi, TmpR4
  fild dword ptr [esi]	; convert quad
  fstp dword ptr [edi]	; to real4
  xor ebx, ebx
  mov eax, [edi] 		; our number as real4 - if it's zero, better do nothing
  .if eax
	mov ebx, 1065353216	; 127 shl 23
	sub eax, ebx
	mov ecx, 83886080		; 10 shl 23
	xor edx, edx			; quite useful before a divide ;-)
	div ecx					; divide eax by ecx

	add edx, ebx			; 127 shl 23
	mov ebx, eax			; ebx holds unit
	mov [edi], edx			; replace with new number (exponent in bits 23...30)
	fld dword ptr [edi]		; show Real4 in Olly
	.if ebx
		push 100				; move 100 into the stack
		fimul dword ptr [esp]		; mul ST (0), 100
	.endif
	fistp dword ptr [esp]		; pop result from FPU stack to CPU stack
	pop eax					; correct the CPU stack, and get the result
  .endif

  mov esi, offset FlexByteBuffer
  invoke dwtoa, eax, esi
  mov edx, offset t0				; default is bytes
  .if ebx							; add the dot if it's more than bytes
	mov edx, [esi+len(esi)-2]	; len returns eax, so we use ecx as accu
	mov cl, "."
	mov [esi+eax-2], cl
	mov [esi+eax-1], edx
	lea edx, [t1+4*ebx-4]				; our unit
  .endif
  invoke lstrcat, esi, edx			; add the xByte unit
  ret
ShowQwFpu endp

dummyFpu proc
dummyFpu endp

ShowQwBsr proc uses edi esi ebx pNum:DWORD
  mov esi, pNum		; pointer to our 8-byte number
  mov edi, offset t0	; default is bytes
  mov ebx, [esi+4]		; test HiDword
  bsr eax, ebx		; get first bit from the left
  jnz H1		; HiDword is set
  mov ebx, [esi]		; test LoDword
  bsr eax, ebx		; get first bit from left
  jz IsZero		; number is zero, special treatment ;-)
  jmp H0

H1:
  add eax, 32		; HiDword was set, so add 32 to the bit count

H0:
  aam		; divide by 10, result in ah, remainder in al
  movzx ecx, ah		; counter
  mov ebx, ecx		; copy of counter
  sal ecx, 2		; *4
  sub edi, ecx		; pointer to the unit and the R4 complements
  push [esi]		; for bytes: push the loword only
  .if ebx
	ffree st(7)					; instead of an "expensive" finit
	fild qword ptr [esi]			; push quad on FPU, and multiply with complements*100
	fmul dword ptr [edi-24]		; to simulate div 1024 and 2 decimals
	fistp dword ptr [esp]			; pop result from FPU stack to CPU stack
  .endif
  pop eax							; our number as an integer
IsZero:
	.if SPT!=2
  mov esi, offset FlexByteBuffer	; a dedicated buffer to display number and unit
  invoke dwtoa, eax, esi
  .if ebx							; add the dot if it's more than bytes
	mov edx, [esi+len(esi)-2]	; len returns eax, therefore
	mov cl, "."					; we use ecx/cl as accu
	mov [esi+eax-2], cl			; insert the dot
	mov [esi+eax-1], edx		; and add the two decimals copied above
  .endif
  invoke lstrcat, esi, edi			; add the xByte unit
	.endif
  ret
ShowQwBsr endp

dummyBsr proc
dummyBsr endp

ShowBytes PROC pqwBytes:PTR QWORD		;http://www.masm32.com/board/index.php?topic=9585.msg70240#msg70240 8 August

    ALIGN 8
    LOCAL tmpReal8:REAL8
    LOCAL hibit:DWORD

    .DATA

        ALIGN 8
        qw8EBi   REAL8 8.67361737988404E-19
        qw8PBi   REAL8 8.88178419700125E-16
        qw8TBi   REAL8 9.09494701772928E-13
        qw8GBi   REAL8 9.31322574615479E-10
        qw8MBi   REAL8 9.5367431640625E-07
        qw8KBi   REAL8 0.0009765625

        psz     PBYTE szB

        szB     BYTE "bytes",0
        szkB    BYTE "kB",0
        szMB    BYTE "MB",0
        szGB    BYTE "GB",0
        szTB    BYTE "TB",0
        szPB    BYTE "PB",0
        szEB    BYTE "EB",0

    .CODE

        ; put a finit somewhere
        mov edx, pqwBytes
        fild QWORD PTR [edx]
        bsr eax, [edx+4]
        jz lodword
        add eax, 32
        mov hibit, eax
        jmp gothibit
      lodword:
        bsr eax, [edx]
        jz done
        mov hibit, eax
      gothibit:
        .IF hibit >= 60
            fmul qw8EBi
            mov psz, OFFSET szEB
        .ELSEIF hibit >= 50
            fmul qw8PBi
            mov psz, OFFSET szPB
        .ELSEIF hibit >= 40
            fmul qw8TBi
            mov psz, OFFSET szTB
        .ELSEIF hibit >= 30
            fmul qw8GBi
            mov psz, OFFSET szGB
        .ELSEIF hibit >= 20
            fmul qw8MBi
            mov psz, OFFSET szMB
        .ELSEIF hibit >= 10
            fmul qw8KBi
            mov psz, OFFSET szkB
        .ENDIF
      done:
        fstp tmpReal8
	.if SPT!=2
		INVOKE crt_printf, chr$("%.2lf %s"), tmpReal8, psz
	.endif
        ret
ShowBytes ENDP

dummyGreg proc
dummyGreg endp

end start

OxPT_Icon	Eye
OPT_Tmp2Asm	1
OPT_WAIT	0
OPT_Linker	polink

pcmpeqb mm0, mm1

; they compare the second operand to the first operand.
; This is exactly opposite of the standard CMP instruction

Entering MMX mode is fairly simple; just execute an MMX instruction.
Exiting MMX isn't as simple.
We use the emms instruction to perform this

psllq shifts a specified register left a certain number of bits, operating on a quadwords (64 bits).
psrlq shifts a specified register right a certain number of bits, operating on a quadwords (64 bits).
This is a logical shift, not arithmetic.

PSLRQ instructions work just like their left shift counterparts except that these instructions
shift their operands to the right rather than to the left. They shift zeros into the vacated H.O.
positions of the destination values.

pcmpgtb performs a 'Greater Than' 8-bit value compare in the same manner as pcmpeqb.
For larger values, the result is all ones (0xff), otherwise zero (0x00).

	; paddq mm3, mm4
	; db 0fh, 0d4h, 0dch

	; psubq mm3, mm4			; subtract 1
;	db 0fh, 0fbh, 0dch			; no opcode, so we do it directly


http://www.masm32.com/board/index.php?topic=9585.msg70136#msg70136
Please forgive my lateness on this - I saw the thread last week but didn't have a chance
to post earlier...

You can achive the result you want with a single divide (it gives the modulo too -
which is important). You need to drive the whole thing off the exponent of a real4.

Pseudo code:
Take the exponent (bits 30 down to 23)
Subtract 127
Divide by 10
Add 127 to the remainder, and replace the exponent in the original number
The result of the division is 0 = bytes, 1 = kilobytes, 2 = megabytes etc.
Print the resulting floating point number (it will be in the range of 0 to 1023.999ish), and
append some string pointed to by the result of the division.

Mirno

;	Mirno, http://www.masm32.com/board/index.php?topic=9585.msg70160#msg70160
;	Take the exponent (bits 30 down to 23)
;	Subtract 127
;	Divide by 10
;	Add 127 to the remainder, and replace the exponent in the original number
;	The result of the division is 0 = bytes, 1 = kilobytes, 2 = megabytes etc.
;	Print the resulting floating point number (it will be in the range of 0 to 1023.999ish), and
;	append some string pointed to by the result of the division.

; The EMMS instruction takes only one clock cycle, but the first floating point instruction after
; an EMMS takes approximately 58 clocks extra, and the first MMX instruction after a floating
; point instruction takes approximately 38 clocks extra.

Simple FPU
		UseMMX = 0
		UseBsr	= 0

		print chr$(13,10,"Simple FPU, ")
		mov eax, dummyFpu-ShowQwFpu
		print ustr$(eax)
		print chr$(" bytes:",13,10)

		TestNum Test0
		TestNum Test1
		TestNum Test2
		TestNum Test3
		TestNum Test4
